﻿using System;
using System.Windows.Forms;
using System.Collections.ObjectModel;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;
using System.IO;


namespace KmlExtensionSample
{
    public partial class TestForm : Form
    {
        public TestForm()
        {
            InitializeComponent();
        }

        private void TestForm_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;
            //winformsMap1.CurrentExtent = new RectangleShape(-122.0874, 37.4245, -122.0804, 37.4201);
            //winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.FromArgb(255, 198, 255, 255));
            //winformsMap1.ZoomLevelSnapping = ZoomLevelSnappingMode.Default;

            //WorldMapKitWmsDesktopOverlay worldMapKitWmsDesktopOverlay = new WorldMapKitWmsDesktopOverlay();
            //winformsMap1.Overlays.Add(worldMapKitWmsDesktopOverlay);

            //KmlFeatureLayer layer = new KmlFeatureLayer("..\\..\\App_Data\\Efate_GPS.kml");
            //layer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            //layer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Black), new GeoSolidBrush(GeoColor.SimpleColors.Yellow));
            //layer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.SimpleColors.Blue, 5));
            //layer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.Green), 10);

            //LayerOverlay stateOverlay = new LayerOverlay();
            //stateOverlay.Layers.Add("KmlLayer", layer);
            //winformsMap1.Overlays.Add("StateOverlay", stateOverlay);

            //winformsMap1.Refresh();
            winformsMap1.MapUnit = GeographyUnit.Meter;
            Proj4Projection proj_KML = new Proj4Projection();
            proj_KML.InternalProjectionParametersString = Proj4Projection.GetEpsgParametersString(4326);
            proj_KML.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();


            KmlFeatureLayer kmllayer = new KmlFeatureLayer("..\\..\\App_Data\\Efate_GPS.kml");
            kmllayer.FeatureSource.Projection = proj_KML;
            kmllayer.Open();
            winformsMap1.CurrentExtent = kmllayer.GetBoundingBox();
            kmllayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = new AreaStyle(new GeoPen(GeoColor.SimpleColors.Black), new GeoSolidBrush(GeoColor.SimpleColors.Yellow));
            kmllayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle = new LineStyle(new GeoPen(GeoColor.SimpleColors.Blue, 5));
            kmllayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new PointStyle(PointSymbolType.Circle, new GeoSolidBrush(GeoColor.SimpleColors.BrightRed), 10);
            kmllayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;


            LayerOverlay KMLOverlay = new LayerOverlay();

            KMLOverlay.Layers.Add("KmlLayer", kmllayer);
            winformsMap1.Overlays.Add("KMLOverlay", KMLOverlay);
            //wpfMap1.Overlays.MoveToTop("KMLOverlay");
            winformsMap1.Refresh();
        }

        private void winformsMap1_MouseMove(object sender, MouseEventArgs e)
        {
            //Displays the X and Y in screen coordinates.
            statusStrip1.Items["toolStripStatusLabelScreen"].Text = "X:" + e.X + " Y:" + e.Y;

            //Gets the PointShape in world coordinates from screen coordinates.
            PointShape pointShape = ExtentHelper.ToWorldCoordinate(winformsMap1.CurrentExtent, new ScreenPointF(e.X, e.Y), winformsMap1.Width, winformsMap1.Height);

            //Displays world coordinates.
            statusStrip1.Items["toolStripStatusLabelWorld"].Text = "(world) X:" + Math.Round(pointShape.X, 4) + " Y:" + Math.Round(pointShape.Y, 4);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
